/***************************************************************************
                          Attribute.h  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//**** Attribute Header

#ifndef ATTRIBUTE_H
#define ATTRIBUTE_H
#include "staticdata.h"
#include "modifiable.h"
#include "dataloader.h"
#include "dice.h"
#include "race.h"
#include <iostream>
#include <string>

/**This class represents an Attribute. It sets the value and
  sets up the extended attribute data. It inherits Modifiable
  *@author Sheldon Lee Wen
  */


class Attribute : public Modifiable
{

public:
  	/** Usable constructor */
 	Attribute(int iAttribute, int iMagnitude);
 	/** Copy constructor */
 	Attribute(const Attribute& rhs);
  	~Attribute();
  	/** returns the string name of the attribute */
  	string getName() const { return attributeName; }
  	/** returns the integer identifier */
  	inline int getIdentifier() const { return attribute; }
  	/**  sets the magnitude to newMagnitude, limited by the maximum value
  		 that an attribute can have ATTRIBUTE_MAXIMUM */
  	virtual int setMagnitude(const int newMagnitude);
  	/** sums all of the existing modifiers and assigns the value to magnitude */
  	virtual int setMagnitude();

      /** Set the extended attribute data. It uses the current magnitude to compute. */
      void setExtData();
      int getExtData(int data);
      #ifdef _DEBUG_
      void print_out();
      #endif

private:
      string parseAttribute(const int iAttribute);
      string attributeName;
      int attribute;
      int extData[4];

};

#endif
