/***************************************************************************
                          Magike.cc  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Sheldon Lee Wen
    email                : sheldonl@linuxstart.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "Magike.h"
#include <iostream.h>

// Functions for ArcaneArt

ArcaneArt::ArcaneArt(Race Irace, bool qual, int val)
{
  extern int rac_lim_aa[13][2];
  if((qualified=qual)==1)
    value=val;
  else
    value=0;

  // Move this stuff to a magic class.
  AALimitations[0]=rac_lim_aa[Irace.race][0];
  AALimitations[1]=rac_lim_aa[Irace.race][1];
}

int ArcaneArt::getValue()
{
  return value;
}

int ArcaneArt::increaseValue(int val)
{
  if(qualified) 
    value+=val;
  return value;
}

bool ArcaneArt::isQualified()
{
  return qualified;
}

bool ArcaneArt::queryAA(ART a)
{

  if(a==AALimitations[0] || a==AALimitations[1])
    return 1;                         // AA not accepted
  else
    return 0;                         // AA accepted
}


// Functions for StateForm

StateForm::StateForm(string n)
{
  name=n;
  level=0;

}

string StateForm::get_name()
{
  return name;
}

int StateForm::get_level()
{
  return level;
}

void StateForm::increase_level(int inc)
{
  level+=inc;
}

// Functions for Aspect

Aspect::Aspect(int asp)
{
  extern char *nameAspects[7];
  extern int numStateForms[7][2];
  extern char *possibleStates[7][9];
  extern char *possibleForms[7][9];
  extern int pointsStateForms[7];
  int i;

  asp_id=asp;
  name=nameAspects[asp];
  powerlevel=1;
  
  numStates=numStateForms[asp][0];
  numForms=numStateForms[asp][1];

  states=new StateForm*[numStates];
  for(i=0; i<numStates; i++) {
     states[i]=new StateForm(possibleStates[asp][i]);
  }

  forms=new StateForm*[numForms];
  if(asp!=shadow) {
    for(i=0; i<numForms; i++) {
      forms[i]=new StateForm(possibleForms[asp][i]);
    }
  } else {
    // Not implemented yet
  }

  ptodistrib=pointsStateForms[asp];

  // Let's test it

  cout << "Aspect: " << name << "\n";
  cout << "States: ";
  for(i=0; i<numStates; i++) 
    cout <<  ((states[i])->get_name()) << " ";
  cout << "\n";

  cout << "Forms: ";
  for(i=0; i<numForms; i++) 
    cout <<  ((forms[i])->get_name()) << " ";
  cout << "\n";  
  
}

Aspect::~Aspect()
{
  int i;

  for(i=0; i<numStates; i++)
    delete states[i];

  for(i=0; i<numForms; i++)
    delete forms[i];

  delete states;
  delete forms;
  
}

void Aspect::distribute()
{
  
}

