/***************************************************************************
                          Magike.h  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Sheldon Lee Wen
    email                : sheldonl@linuxstart.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef MAGIKE_H
#define MAGIKE_H

#ifndef TYPES_H
 #define TYPES_H
 #include "Types.h"
#endif

#include <string>

class Spell {
  string name;
  int difficulty;
  RANGE range;
  int thres_adj;
  DURATION duration;
  AREA area;
  ASPECT aspect;
  unsigned int state_mask;
  unsigned long int form_mask;
  // Components?
  // Effects of resistance?
};

class ArcaneArt {
  bool qualified;
  int value;
  int AALimitations[2];
  ART ArcaneArtValue;

public:
  ArcaneArt(bool qual, int val);
  int getValue();
  int increaseValue(int val);
  bool isQualified();
  bool queryAA(ART a);
};

class StateForm {
  string name;
  int level;
public:
  StateForm(string n);
  //~StateForm();
  int get_level();
  void increase_level(int inc);
  char *get_name();
};

class Aspect {
  int asp_id;
  string name;
  int powerlevel;
  int numStates;
  int numForms;
  StateForm **states;
  StateForm **forms;
  int ptodistrib;
public:
  Aspect(int asp);
  ~Aspect();
  void distribute();
};  

#endif

