/***************************************************************************
                          bodyarea.cpp  -  description
                             -------------------
    begin                : Tue Dec 4 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bodyarea.h"
/** Default Constructor */
BodyArea::BodyArea() : bodyareaName(""), bodyarea(-1), bodyareaMaximum(-1), status(-1) {
   bodyareaName="";
   bodyarea=-1;
   bodyareaMaximum=-1;
   status=-1;
   magnitude = bodyareaMaximum;
}
/** Usable constructor */
BodyArea::BodyArea(int bArea, int hpTotal) : bodyarea(bArea), bodyareaMaximum(hpTotal) {
   magnitude = bodyareaMaximum;
   bodyareaName=parseBodyArea(bArea);
   status = 0;
}
/** Copy Constructor */
BodyArea::BodyArea(const BodyArea &rhs) : Modifiable(rhs), bodyareaName(rhs.bodyareaName), bodyarea(rhs.bodyarea), bodyareaMaximum (rhs.bodyareaMaximum), status(rhs.status)  {
}

/** Operator overloading */
//const BodyArea &BodyArea::operator=( const BodyArea & rhs) {
//   if (this != &rhs ) {
      /** Use the Modifiable::operator= to copy the base objects */
//      Modifiable *ptr = this;
//      Modifiable *ptr2 = const_cast<BodyArea*>(&rhs);
//      *ptr = *ptr2;
      /** Copy the body area values */
//      bodyareaName = rhs.bodyareaName;
//      bodyarea = rhs.bodyarea;
//      bodyareaMaximum = rhs.bodyareaMaximum;
//      status = rhs.status;
//   }
//   return *this;
//}

BodyArea::~BodyArea(){
}
/** returns the name of the attribute in string form. */
string BodyArea::getName() const{
   return (bodyareaName);
}
/** Sets the magnitude to newMagnitude, limited by the maximum value that a
body area can have, determined by race. */
int BodyArea::setMagnitude(const int newMagnitude){
   if (newMagnitude > bodyareaMaximum)
      magnitude = bodyareaMaximum;
   return (magnitude);
}
/** sums all of the existing modifiers and assigns the value to magnitude */
int BodyArea::setMagnitude(){
   setMagnitude(sumOfAllModifiers());
   return (magnitude);
}
/** Internal method that parses out the string name of the body area from it's integer value. */
string BodyArea::parseBodyArea(const int iBodyArea){
   dLoader *table = new dLoader();
   string *batbl = table->getBodyNameLookupTable();
   delete(table);
   return (batbl[bodyarea]);
}
/** Read property of int status. */
int BodyArea::getstatus() const {
	return status;
}
/** Write property of int status. */
void BodyArea::setstatus( const int _newVal){
	status = _newVal;
}
/** Read property of int bodyareaMaximum. */
int BodyArea::getbodyareaMaximum() const {
	return bodyareaMaximum;
}
/** Write property of int bodyareaMaximum. */
void BodyArea::setbodyareaMaximum( const int _newVal){
	bodyareaMaximum = _newVal;
}
#ifdef _DEBUG_
void BodyArea::print_out() {
         cout << "Name = " << bodyareaName << " : ident = " << bodyarea;
         cout << " : maximum = " << bodyareaMaximum << " : status = " << status;
         cout << endl;
         Modifiable *ptr = this;
         ptr->print_out();
}
#endif

