/***************************************************************************
                          character.cpp  -  description
                             -------------------
    begin                : Fri Dec 7 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "character.h"

Character::Character(int iRace, int iGender) : Race(iRace, iGender) {
   init();
}
Character::Character(const Race& iRace) : Race(iRace) {
   init();
}
Character::Character(const Character& rhs) : Race(rhs) {
   init();
}
/** Operator overloading */
const Character &Character::operator=( const Character & rhs) {
   if (this != &rhs ) {
      /** Use the Race::operator= to copy the base objects */
      Race *ptr = this;
      Race *ptr2 = const_cast<Character*>(&rhs);
      *ptr = *ptr2;

      /** Copy the character specific values */
      // Fill in here.
      //Copy the attributes
   }
   return *this;
}
Character::~Character(){
   for (int i=0; i<NUM_ATTRIBUTES;i++)
      delete attributes[i];
}
/** Initialize the character by creating the attribute objects and rolling a default value for them. */
void Character::init(){
   Dice d;
   attributes.insert(attributes.begin(), new Attribute(WILLPOWER, d.roll() + getAttributeBonus(WILLPOWER)));
   int wpm = attributes[WILLPOWER]->getExtData(WP_ATTRIBUTE);
   for (int i=STRENGTH; i<NUM_ATTRIBUTES;i++){
      attributes.insert(attributes.begin()+i, new Attribute(i,d.roll() + getAttributeBonus(i) + wpm));
   }
}
/** Rolls the attributes and add Racial and WP bonuses */
void Character::rollAttributes()
{
   Dice d;
   /** Determine WP so we can apply the WP bonuses if any */
   delete (attributes[WILLPOWER]);
   attributes[WILLPOWER] = new Attribute(WILLPOWER, d.roll() + getAttributeBonus(WILLPOWER));
   int wpbonus = attributes[WILLPOWER]->getExtData(WP_ATTRIBUTE);

   /** Setup the attrbute values */
   for (int i=STRENGTH; i<NUM_ATTRIBUTES;i++){
      delete (attributes[i]);
      attributes[i] = new Attribute(i, d.roll() + getAttributeBonus(i) + wpbonus);
   }
}

#ifdef _DEBUG_
void Character::print_out() {
//         cout << "Name = " << attributeName << " : ident = " << attribute;
         for (int i=0; i<NUM_ATTRIBUTES; i++)
            attributes[i]->print_out();
         cout << endl;
         Race *ptr = this;
         ptr->print_out();

}
#endif
/** Read property of string name. */
const string& Character::getname(){
	return name;
}
/** Write property of string name. */
void Character::setname( const string& _newVal){
	name = _newVal;
}
