/***************************************************************************
                          character.h  -  description
                             -------------------
    begin                : Fri Dec 7 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHARACTER_H
#define CHARACTER_H
#include "race.h"
#include "Attribute.h"

/**This class contains a Lycadican character.

  *@author Sheldon Lee Wen
  */

class Character : public Race
{
public: // Public attributes
   Character(int iRace, int iGender);
   Character(const Race &iRace);
   Character(const Character &rhs);
   const Character &operator=(const Character &rhs);
   ~Character();

   #ifdef _DEBUG_
   void print_out();
   #endif

   /** Roll the attributes and add Racial and WP bonuses */
   void rollAttributes();
  /** Write property of string name. */
  virtual void setname( const string& _newVal);
  /** Read property of string name. */
  virtual const string& getname();
   /** Contains the characters attributes. */
   vector<Attribute*> attributes;
  /** Name of the character. */
  string name;


//  AGELEVEL age;
//  int weight;
//  int height;
//  Money wealth;
//  int xp;
//  int cdp;
//  ALIGNMENT alignment;
//  TENDENCY tendency;
//  PROFESSION profession;
//  S_CLASS s_class;
//  HANDEDNESS handedness;
//  int soul_strength;

// Magike stats
//  bool magike_wielder;
//  int psychi;
//  BODYPART waatosi;
//  int life_points;
//  int laws[4];        // The four laws of magike
//  ArcaneArt *arts[5];
//  Aspect *aspects[7];


private:
   void init();
};

#endif
