/***************************************************************************
                          dataloader.cpp  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Sheldon Lee-Wen
    email                : tormak@home.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dataloader.h"
#include <cstdlib>
#include <iostream>

dLoader::dLoader() {
}

dLoader::~dLoader() {
}

void* dLoader::getTable(int tableType) {

	switch (tableType)
	{
	   case RACIAL_ATTRIBUTE_TABLE:
	      return ((void *)&rac_atts);
	      break;
	   case AGE_LEVEL_TABLE:
	      return ((void*)&age_levels);
	      break;
	   case HEALTH_POINT_TABLE:
	      return ((void*)&race_hp_maximums);
           break;
         case DEFENSE_RATING_TABLE:
            return ((void*)&defense_rating);
            break;
         case ATTRIBUTE_NAME_LOOKUP:
         case GENDER_NAME_LOOKUP:
         case RACE_NAME_LOOKUP:
         case AGE_LEVEL_NAME_LOOKUP:
         case BODY_AREA_NAME_LOOKUP:
         default:
     	      return (NULL);
    }
    return (NULL);
}

int* dLoader::getextData(int attribute, int score) const {
   if ( score <= 0 ) score=1;

	switch (attribute)
	{
		case WILLPOWER:
			return ((int*)willpower_extdata[score-1]);
			break;
		case STRENGTH:
			return ((int*)strength_extdata[score-1]);
			break;
		case INTELLIGENCE:
			return ((int*)intelligence_extdata[score-1]);
			break;
		case WIT:
			return ((int*)wit_extdata[score-1]);
			break;
		case DEXTERITY:
			return ((int*)dexterity_extdata[score-1]);
			break;
		case CONSTITUTION:
			return ((int*)constitution_extdata[score-1]);
			break;
		case MOVEMENT:
			return ((int*)movement_extdata);
			break;
		default:
			return (NULL);
			break;
		}
	return (NULL);
}

int dLoader::getextData(int attribute) const {
	return (attribute_extdata_numdata[attribute]);
}

int* dLoader::getRacialAttributeTable(int race, int gender) {
	return ((int*)rac_atts[race][gender]);
}

int* dLoader::getAgeLevelTable(int agelevel) {
	return ((int*)age_levels[agelevel]);
}

int* dLoader::getHealthPointTable(int race) {
	return ((int*)race_hp_maximums[race]);
}

int* dLoader::getDefenseRatingTable() {
	return ((int*)defense_rating);
}

string* dLoader::getAttributeNameLookupTable() {
	return ((string*)attribute_name_lookup);
}

string* dLoader::getGenderNameLookupTable() {
	return ((string*)gender_name_lookup);
}

string* dLoader::getRaceNameLookupTable() {
	return ((string*)race_name_lookup);
}

string* dLoader::getAgeLevelNameLookupTable() {
	return ((string*)age_level_name_lookup);
}

string* dLoader::getBodyNameLookupTable() {
	return ((string*)body_name_lookup);
}