/***************************************************************************
                          dataloaderdata.h  -  description
                             -------------------
    begin                : Sun Nov 11 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
	***************************************************************************/

#ifndef DATALOADERDATA_H
#define DATALOADERDATA_H
#include "staticdata.h"

static const string attribute_name_lookup[NUM_ATTRIBUTES] = {"Will Power", "Strength", "Intelligence", "Wit", "Dexterity", "Constitution", "Appearance", "Personality", "Movement" };
static const string race_name_lookup[NUM_RACES] = {"Arakasha", "Asura", "Belox", "Chahannawashea", "Culgan", "Human", "Kinn", "Midian", "Rocc", "Sivakxy", "Vorlex"};
static const string gender_name_lookup[NUM_GENDERS] = {"Male", "Female" };
static const string age_level_name_lookup[NUM_AGE_LEVELS] = {"Adolecent", "Adult", "Senior", "Venerable"};
static const string body_name_lookup[BODY_NUM_BODY] = {"Head","Torso","Left Arm","Right Arm","Left Leg","Right Leg","Left Wing","Right Wing","Tail"};

	
//Racial Attrib Table    			         WP, Str, Int, Wit, Dex, Con, App, Per, Mv
//																MALE							FEMALE
static const int rac_atts[NUM_RACES][NUM_GENDERS][NUM_ATTRIBUTES]={
	{ {0,2,-1,0,0,1,-1,0,0},  {1,1,-1,0,0,0,-1,0,0}   }, // Arakasha
	{ {2,0,1,1,2,-1,2,1,0},   {2,0,1,1,2,-1,2,1,0}    }, // Asura	
	{ {1,-1,1,0,2,-1,2,1,3},  {1,-2,1,0,2,-1,2,1,3}   }, // Belox
    { {1,1,1,1,2,0,2,-1,0},   {2,0,1,1,2,0,3,-1,0}    }, // Chahannawashea
	{ {1,2,1,-1,1,0,-1,-1,0}, {1,2,1,-1,1,0,-1,-1,1} }, // Culgan
	{ {2,1,2,1,0,0,1,0,0},     {2,0,2,1,0,0,2,0,0}     }, // Human
	{ {0,1,1,0,2,1,0,1,0},     {0,1,1,0,2,1,0,1,0}     }, // Kinn
	{ {1,1,0,1,2,1,-1,0,0},    {1,1,0,1,2,1,-1,0,0}    }, // Midian
	{ {0,3,-1,-1,0,1,-1,0,0},  {0,3,-1,-1,0,1,-1,0,0} }, // Rocc
	{ {1,0,2,0,0,-1,1,0,0},    {1,0,2,0,0,-1,1,0,0}    }, // Sivakxy
	{ {0,2,1,0,0,1,0,0,0},     {0,2,1,0,0,1,0,0,1}      } // Vorlex
};
						
static const int age_levels[NUM_AGE_LEVELS][NUM_ATTRIBUTES+1] = {
//   WP, Str, Int, Wit, Dex, Con, App, Per, Mv, CDP
	{ 1, 1, 0, -1, 1, 1, 0, 0, 0, 0 }, // Adolecent
    { 0, 1, 1, 1, 0, 1, 0, 0, 0, 5 }, // Adult
	{ 0,-2, 1, 1,-2,-2, 0, 0, 0, 10 }, // Senior
    {-5,-5,-5,-5,-5,-5,-5,-5,-5, 0 } // venerable
};
						
static const int race_hp_maximums[NUM_RACES][NUM_BODY]= {
//Head  Torso  Arm Leg Wing Tail
	{35,   100,   25, 36, 0, 0}, //Arakasha
	{14,   67,    22, 30,  0, 0}, // Asura
	{8,    30,    13, 16,  0, 0}, // Belox
	{17,   58,    20, 30,  0, 0}, // Chahannawashea
	{9,    58,    18, 22,  10, 0}, // Culgan
	{8,    51,    14, 18,  0, 0}, // Human
	{14,   75,    28, 30,  0, 0}, // Kinn
	{14,   60,    14, 22,  0, 0}, // Midian
	{20,   95,    22, 34, 20, 0}, // Rocc
	{13,   50,    18, 28,  0, 0}, // Sivakxy
	{35,   115,   34, 38, 25, 0}  // Vorlex
};
//index:races                                                          A   AS B C  C H K M R  S V
static const int defense_rating[NUM_RACES] = {5,  5,   6, 5, 5, 3, 4, 6, 3, 4, 5, };

static const int willpower_extdata[ATTRIBUTE_MAXIMUM][WP_NUMDATA] = {
	{-2, -2, -2, -2},	// Score 1
	{-1, -1, -1, -1}, // Score 2
	{0, 0, 0, 0}, // Score 3
	{0, 0, 0, 0}, // Score 4
	{0, 0, 0, 0}, // Score 5
	{0, 0, 0, 0}, // Score 6
	{0, 0, 0, 0}, // Score 7
	{3, 1, 0, 1}, // Score 8
	{4, 2, 1, 1}, // Score 9
	{5, 3, 2, 2} }; // Score 10
	
static const int strength_extdata[ATTRIBUTE_MAXIMUM][STRENGTH_NUMDATA] = {
	{-100, -2}, // Score 1
	{-50, -1}, // Score 2
	{-10, 0}, // Score 3
	{0, 0}, // Score 4
	{0, 0}, // Score 5
	{50, 0}, // Score 6
	{100, 1}, // Score 7
	{200, 2}, // Score 8
	{300, 3}, // Score 9
	{400, 4} }; // Score 10

static const int intelligence_extdata[ATTRIBUTE_MAXIMUM][INTELLIGENCE_NUMDATA] = {
	{-3, -50},
	{-2, -40},
	{-1, -30},
	{0, -20},
	{0, -10},
	{0, 0},
	{0, 10},
	{1, 30},
	{2, 60},
	{3, 100} };

static const int dexterity_extdata[ATTRIBUTE_MAXIMUM][DEXTERITY_NUMDATA] = {
	{-4, -4, -3, -2},
	{-2, -2, -2, -1},
	{-1, -1, -1, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 1, 0},
	{1, 1, 1, 1},
	{2, 2, 1, 1},
	{3, 3, 1, 2} };

static const int wit_extdata[ATTRIBUTE_MAXIMUM][WIT_NUMDATA] = {
	{6, -2, -2},
	{5, -1, -1},
	{4, 0, 0},
	{3, 0, 0},
	{2, 0, 0},
	{1, 0, 0},
	{0, 0, 0},
	{0, 1, 1},
	{0, 2, 1} };

static const int constitution_extdata[ATTRIBUTE_MAXIMUM][CONSTITUTION_NUMDATA] = {
	{-2, 0, 0},
	{-1, 0, 0},
	{0, 1, 0},
	{0, 1, 0},
	{0, 2, 0},
	{1, 2, 0},
	{2, 3, 0},
	{3, 4, 0},
	{4, 1, 1},
	{5, 1, 3} };
	
static const int movement_extdata[ATTRIBUTE_MAXIMUM+5] = {-2,-1,0,0,0,0,0,0,1,1,1,2,2,2,3};	
static const int attribute_extdata_numdata[NUM_ATTRIBUTES] = {4,2,2,4,3,3,0,0,1};
	
#endif