/***************************************************************************
                          dice.cpp  -  description
                             -------------------
    begin                : Fri Jan 26 2001
    copyright            : (C) 2001 by Sheldon Lee-Wen
    email                : sheldonl@linuxmail.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "dice.h"

Dice::Dice() {
	init();
}

Dice::~Dice() {
}

void Dice::init() {
     target=10;
     result=0;
     modifiedResult=0;
     dos=-500;
}

int Dice::roll() {
	rollProcedural();
	int tmpresult=result;
	init(); // Leave the internal state of the die clean.
	return (tmpresult);
}

int Dice::rollProcedural() {
	init();
	result = 1+(int) (10.0*rand()/(RAND_MAX+1.0));
	modifiedResult=result;
	return result;
}

int Dice::rollBoundless() {
	int roll;

	init();
	roll = 1+(int) (10.0*rand()/(RAND_MAX+1.0));
	result = roll;

  while (roll == 1 || roll == 10)
  {
      if (roll == 1)
      {
         roll = 1+(int) (10.0*rand()/(RAND_MAX+1.0));
         if (roll != 10)
            result-= roll;
      }
      else
      {
         roll = 1+(int) (10.0*rand()/(RAND_MAX+1.0));
         if (roll != 1)
            result += roll;
      }
  }
	modifiedResult=result;
	return result;
}

bool Dice::attributeCheck(int attribute, int mods) {
	init();
	int tmpresult = (1+(int) (10.0*rand()/(RAND_MAX+1.0)) + attribute) + mods;
	if (tmpresult-10 >= 0)
		return true;
	return false;
}

int Dice::attributeCheck(int attribute, int mods, int shift) {
	init();
	int tmpresult = (1+(int) (10.0*rand()/(RAND_MAX+1.0)) + attribute) + mods;
	return (tmpresult+shift);
}

int Dice::rollPercent() {
	init();
	return (1+(int) (100.0*rand()/(RAND_MAX+1.0)));
}

bool Dice::success(int tgt=10, int mods=0) {
   if (tgt > 0)
      target = tgt;
   modifiedResult=mods + result;
   dos = modifiedResult - target;
   if (result >= target)
      return true;
   return false;
}

int Dice::degreeOS(int shift=0) {
	return (dos += shift);
}