/***************************************************************************
                          modifiereventgenerator.cpp  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "modifiereventgenerator.h"

modifierGenerator::modifierGenerator(){
  type = EVENT_MODIFIER;
}

modifierGenerator::~modifierGenerator(){

  unsigned int i;

  // remove generator from all registered listeners
  for (i = 0; i < modifierListeners.size(); i++)
    modifierListeners[i]->removeModifierGenerator(this);
}

void modifierGenerator::fireModifierEvent(modifierEvent &evt)
{
  unsigned int i;

//  evt->setSource(this);
  evt.setSource(this);

  for (i = 0; i < modifierListeners.size(); i++)
    modifierListeners[i]->handleModifierEvent(evt);
}

int modifierGenerator::findModifierListener(modifierListener *l)
{
  unsigned int i;

  for (i = 0; i < modifierListeners.size(); i++)
    if (l == modifierListeners[i])
      return (i);

  return (-1);  // not found
}

void modifierGenerator::addModifierListener(modifierListener *l)
{
  /* make sure the listener isn't already installed - inefficient
   * linear search due to vector.  This isn't absolutely necessary, but
   * provides error checking to prevent multiple additions
   */

  if (findModifierListener(l) < 0)
  {
      l->addModifierGenerator(this);
      modifierListeners.push_back(l);
  }
}

void modifierGenerator::removeModifierListener(modifierListener *l)
{
    int i;
    vector<modifierListener *>::iterator it;

    /* locate the index within the list */
    i = findModifierListener(l);

  it = &modifierListeners[i];

  if (i >=0)    // if the listener is in the vector
    modifierListeners.erase(it);
}
