/***************************************************************************
                          modifiereventgenerator.h  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MODIFIEREVENTGENERATOR_H
#define MODIFIEREVENTGENERATOR_H

#include "modifiereventlistener.h"
#include "modifierevent.h"
#include "event.h"
#include "staticdata.h"

#include <iostream>

/**Generates an event for the modifier event system.
This is required to register the event listeners.
  *@author Sheldon Lee Wen
  */
class modifierListener;
class modifierEvent;

class modifierGenerator : public event_generator  {
public: 
	modifierGenerator();
	~modifierGenerator();
	
  void fireModifierEvent(modifierEvent &evt);
  void addModifierListener(modifierListener *l);
  void removeModifierListener(modifierListener *l);

#ifdef _DEBUG_
  void print() { ___DEBUG(I am generator:,this); }
#endif

 private:
  vector<modifierListener *> modifierListeners;
  int findModifierListener(modifierListener *l);
};

#endif
