/***************************************************************************
                          modifiereventlistener.cpp  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001 by Sheldon Lee Wen
    email                : tormak@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "modifiereventlistener.h"



modifierListener::modifierListener(){
  type = EVENT_MODIFIER;
}
modifierListener::~modifierListener(){
#ifdef _DEBUG_
 __DEBUG(destructing the listener);
#endif
  // remove listener from all registered generators.
  for (unsigned int i = 0; i < modifierGenerators.size(); i++)   {
#ifdef _DEBUG_
 modifierGenerators[i]->print();
 __DEBUG(unregistering generator.....);
#endif
      modifierGenerators[i]->removeModifierListener(this);
#ifdef _DEBUG_
 __DEBUG(done);
#endif
  }
  // remove all of the generators from the listener.
  modifierGenerators.clear();
#ifdef _DEBUG_
 __DEBUG(destruction complete);
#endif
}

int modifierListener::findModifierGenerator(modifierGenerator *g)
{
  unsigned int i;

  for (i = 0; i < modifierGenerators.size(); i++)
    {
      if (g == modifierGenerators[i])
        return(i);
    }

  return (-1);
}

void modifierListener::addModifierGenerator(modifierGenerator *g)
{
   modifierGenerators.push_back(g);
}

void modifierListener::removeModifierGenerator(modifierGenerator *g)
{
  int i;
  vector<modifierGenerator *>::iterator it;

  /* locate the index within the list */
  i = findModifierGenerator(g);
  it = &modifierGenerators[i];

  if (i >=0)    // if the generator is in the vector
    modifierGenerators.erase(it);
}

void modifierListener::handleModifierEvent(modifierEvent &evt)
{
  cout << "If you see this message it's because you haven't defined the handelModifierEvent() method in the class you derived from modifierListener\n";
  cout << "Received Modifier event!\n";
  cout << "Scope is" << evt.getScope() << endl;
  cout << "Value is" << evt.getValue() << endl;
}