/***************************************************************************
                          staticdata.h  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Sheldon Lee-Wen
    email                : sheldonl@linuxmail.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STATICDATA_H
#define STATICDATA_H

#define __DEBUG(x) cout << #x << endl;
#define ___DEBUG(x,y) cout << #x << y << endl;

// Definitions for various table indexes and identifiers.
// Table Types
#define RACIAL_ATTRIBUTE_TABLE 0
#define AGE_LEVEL_TABLE 1
#define HEALTH_POINT_TABLE 2
#define DEFENSE_RATING_TABLE 3
#define ATTRIBUTE_NAME_LOOKUP 4
#define GENDER_NAME_LOOKUP 5
#define RACE_NAME_LOOKUP 6
#define AGE_LEVEL_NAME_LOOKUP 7
#define BODY_AREA_NAME_LOOKUP 8
// Race Names, needed to index the tables
#define NUM_RACES 11
#define ARAKASHA  0
#define ASURA   1
#define BELOX  2
#define CHAHANNAWASHEA  3
#define CULGAN  4
#define HUMAN  5
#define KINN  6
#define MIDIAN 7
#define ROCC  8
#define SIVAKXY 9
#define VORLEX  10
// Age Level's needed to index tables
#define NUM_AGE_LEVELS  4
#define ADOLECENT 0
#define ADULT 1
#define SENIOR 2
#define VENERABLE 3
#define CDP_BONUS 3
// Body areas needed to index the health table
#define NUM_BODY 6
#define HEAD 0
#define TORSO 1
#define ARM 2 	
#define LEG 3
#define WING 4
#define TAIL 5
// Body areas needed to index an array of body areas
#define BODY_HEAD 0
#define BODY_TORSO 1
#define BODY_LEFT_ARM 2
#define BODY_RIGHT_ARM 3
#define BODY_LEFT_LEG 4
#define BODY_RIGHT_LEG 5
#define BODY_LEFT_WING 6
#define BODY_RIGHT_WING 7
#define BODY_TAIL 8
#define BODY_NUM_BODY 9
// Gender types
#define NUM_GENDERS 2
#define MALE 0
#define FEMALE 1
// Attribute types
#define NUM_ATTRIBUTES  9
#define ATTRIBUTE_MAXIMUM 10
#define WILLPOWER 0
#define STRENGTH 1
#define INTELLIGENCE 2
#define WIT 3
#define DEXTERITY 4
#define CONSTITUTION 5
#define APPEARANCE 6
#define PERSONALITY 7
#define MOVEMENT 8

#define WP_NUMDATA 4
#define WP_EXPERIENCE 0
#define WP_HP 1
#define WP_RESIST 2
#define WP_ATTRIBUTE 3

#define STRENGTH_NUMDATA 2
#define STRENGTH_WEIGHT_BONUS 0
#define STRENGTH_IMPACT_DAMAGE 1

#define INTELLIGENCE_NUMDATA 2
#define INTELLIGENCE_SKILL 0
#define INTELLIGENCE_PSYCHE 1

#define DEXTERITY_NUMDATA 	4
#define DEXTERITY_ELITE_SKILL_MODIFIER 0
#define DEXTERITY_DEFENSE_MODIFIER 1
#define DEXTERITY_MISSLE_HIT 2
#define DEXTERITY_MELEE_HIT 3

#define WIT_NUMDATA 3
#define WIT_VOLATILE_MAGIKE 0
#define WIT_MIND_ATTACK 1
#define WIT_FIRST_STRIKE 2

#define CONSTITUTION_NUMDATA 3
#define CONSTITUTION_HP 0
#define CONSTITUTION_REGENERATION 1
#define CONSTITUTION_REGENERATION_PERIOD 2
#define CONSTITUTION_REGENERATION_PERIOD_DAY 0
#define CONSTITUTION_REGENERATION_PERIOD_TURN 1
#define CONSTITUTION_REGENERATION_PERIOD_ROUND 3



typedef int EVENT_TYPE;
#define EVENT_UNDEFINED 0
#define EVENT_TICK 1
#define EVENT_MINUTE 2
#define EVENT_DAY 3
#define EVENT_NIGHT 4
#define EVENT_ENCOUNTER 5
#define EVENT_WEATHER 6
#define EVENT_DARK 7
#define EVENT_LIGHT 8
#define EVENT_MAGIC 9
#define EVENT_COMBAT 10
#define EVENT_MODIFIER 11
	
#endif
